/*
 *******************************************************************************
 * $Header: /RD_1/Project/VNDP/MainProfile/DRMControl/src/DRMControl.h 4     06/10/30 6:17p Shengfu $
 *
 *  Copyright (c) 2000-2002 Vivotek Inc. All rights reserved.
 *
 *  +-----------------------------------------------------------------+
 *  | THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY ONLY BE USED |
 *  | AND COPIED IN ACCORDANCE WITH THE TERMS AND CONDITIONS OF SUCH  |
 *  | A LICENSE AND WITH THE INCLUSION OF THE THIS COPY RIGHT NOTICE. |
 *  | THIS SOFTWARE OR ANY OTHER COPIES OF THIS SOFTWARE MAY NOT BE   |
 *  | PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY OTHER PERSON. THE   |
 *  | OWNERSHIP AND TITLE OF THIS SOFTWARE IS NOT TRANSFERRED.        |
 *  |                                                                 |
 *  | THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT   |
 *  | ANY PRIOR NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY |
 *  | VIVOTEK INC.                                                    |
 *  +-----------------------------------------------------------------+
 *
 * $History: DRMControl.h $
 * 
 * *****************  Version 4  *****************
 * User: Shengfu      Date: 06/10/30   Time: 6:17p
 * Updated in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * update to version 2.0.0.2
 * 
 * *****************  Version 3  *****************
 * User: Shengfu      Date: 06/10/04   Time: 9:59a
 * Updated in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * update to 2.0.0.1
 * 
 * *****************  Version 2  *****************
 * User: Shengfu      Date: 05/10/28   Time: 5:30p
 * Updated in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 05/07/26   Time: 4:16p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 05/07/26   Time: 1:50p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/DRMControl/src
 * 
 * *****************  Version 2  *****************
 * User: Perkins      Date: 05/06/28   Time: 4:09p
 * Updated in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * must add extern C for cpp user
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 04/11/24   Time: 2:08p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/src
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 04/11/24   Time: 2:05p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/DRMControl/src
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 04/11/24   Time: 2:04p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/DRMControl/src
 * 
 * *****************  Version 1  *****************
 * User: Perkins      Date: 04/11/24   Time: 2:02p
 * Created in $/RD_1/Project/VNDP/MainProfile/DRMControl/DRMControl/src
 * 
 * *****************  Version 2  *****************
 * User: Shengfu      Date: 04/03/22   Time: 1:29p
 * Updated in $/rd_1/Protocol/Modules/DRMClientLib
 *
 *******************************************************************************
 */

/*!
 *******************************************************************************
 * Copyright 2000-2002 Vivotek, Inc. All rights reserved.
 *
 * \file
 * DRMControl.h
 *
 * \brief
 * Vivotek Machine Discovery, Registration Mechanism
 *
 * \date
 * 2002/12/05
 *
 * \author
 * Simon Chen
 *
 *
 *******************************************************************************
 */

#ifndef _DRMControl_H_
#define _DRMControl_H_

#include "typedef.h"
#include "common.h"

//typedef long SCODE;
/*!
 * FOUR_CC Version code of your \b DRMControl, you should update it if you have
 * changed your \b DRMControl's interface.
 */
#define DRMControl_VERSION			MAKEFOURCC(3, 1, 0, 1)
#define DRMCONTROL_MAX_CAMERA_ID	16
#define DRMCONTROL_MAX_CAMERA_NAME	96
#define DRMCONTROL_MACHINE_TYPE		44
#define DRMCONTROL_MAX_MODEL_NAME	44
#define DRMCONTROL_MAX_IP_LENGTH	20
#define DRMCONTROL_MAC_LENGTH		6
#define DRMCONTROL_MAX_LANG_LENGTH	6

/*! Enumeration of Firmware type*/
typedef enum
{
	/*! Firmware type is Farseer*/
	FirmwareType_farseer = 0,

	/*! Firmware type is Anubis*/
	FirmwareType_anubis  = 1,

} EDRMControl_FirmwareType;

/*! Enumeration of StreamType type*/
typedef enum
{
	/*! Single Stream*/
	StreamType_SingleStream     = 0,

	/*! Pseudo Dual Stream*/
	StreamType_PseudoDualStream = 1,

	/*! Dual Stream*/
	StreamType_DualStreams		= 2,

	/*! Triple streams*/
	StreamType_TripleStreams    = 3,

	/*! Four streams*/
	StreamType_FourStreams      = 4,

	/*! Five streams*/
	StreamType_FiveStreams      = 5,

	/*! Six streams*/
	StreamType_SixStreams       = 6,

	/*! Seven streams*/
	StreamType_SevenStreams     = 7,

} EDRMControl_StreamType;

/*! Enumeration of Channel number (for video server)*/
typedef enum
{
	/*! Indicates one channel*/
	ChannelNumber_OneChannel    = 0,

	/*! Indicates two channels*/
	ChannelNumber_TwoChannels   = 1,

	/*! Indicates three channels*/
	ChannelNumber_ThreeChannels = 2,

	/*! Indicates four channels*/
	ChannelNumber_FourChannels  = 3,

	/*! Indicates five channels*/
	ChannelNumber_FiveChannels  = 4,

	/*! Indicates six channels*/
	ChannelNumber_SixChannels   = 5,

	/*! Indicates seven  channels*/
	ChannelNumber_SevenChannels = 6,

	/*! Indicates eight channels*/
	ChannelNumber_EightChannels = 7,
	
} EDRMControl_ChannelNumber;

/*! Enumeration of Firmware architecture ID*/
typedef enum
{
	/*! Using config.ini(2000, 3000, 6000 series, IP7135/7, IP7131/2)*/
	FirmwareArchID_Ini = 0,

	/*! Using XML configuration file(RX, IP7138, VS7100, ...)*/
	FirmwareArchID_Xml = 1,

} EDRMControl_FirmwareArchID;

/*! Definition of TEZInstallCap structure.
 *  The TEZInstallCap is used to store the EZ Installation capability. */
typedef struct TEZInstallCap
{
	/*! Determine whether the device supports smart mode*/
	BOOL bS_MODE;

	/*! Firmware type*/
	EDRMControl_FirmwareType eFW_Type;

	/*! EZ Installation version*/
	unsigned short uVersion;

	/*! Support stream type*/
	EDRMControl_StreamType eStreamType;

	/*! Channel number*/
	EDRMControl_ChannelNumber eChannelNumber;

	/*! Determine whether the device uses Permodia Proxy*/
	BOOL bUsePermodiaPorxy;

	/*! Firmware architecture ID*/
	EDRMControl_FirmwareArchID eFW_ID;

}TEZInstallCap;

/*! A data structure of \b TDRMServiceInfo object. Used in callback function
 *  to report the discovery result or Service registration information. */
typedef struct tagTDRMServiceInfo{
	/*! Type of machine (firmware version) */
	char  acMachineType[DRMCONTROL_MACHINE_TYPE]; 

	/*! Mac of machine */
	BYTE abyMac[DRMCONTROL_MAC_LENGTH];

	/*! IP */
	char acIP[DRMCONTROL_MAX_IP_LENGTH];

	/*! Model name of machine */
	char  acModelName[DRMCONTROL_MAX_MODEL_NAME]; 
	
	unsigned short sHTTPPort;
	unsigned short sFTPPort;
	char  acLanguage[DRMCONTROL_MAX_LANG_LENGTH];
	/*! EZ installation version */
	DWORD dwEZversion;

	/*! Camera name */
	char acCameraName[DRMCONTROL_MAX_CAMERA_NAME + 1]; 

	/*! Network Card IP */
	char acNetworkCardIP[DRMCONTROL_MAX_IP_LENGTH];

	/*! CMS port */
	unsigned short sCMSPort;

	/*! CameraID address */
	char acCameraID[DRMCONTROL_MAX_CAMERA_ID + 1];

	/*! HTTPS port */
	unsigned short sHTTPSPort;

} tagTDRMServiceInfo;

/*! Enumeration of /b FDRMControlCallback callback type. */
typedef enum
{

	/*! After the discovery has finished. */
	DRMControl_Callback_DiscoveryResult = 1,

	/*! When Service registers to this controller. */
	//DRMControl_Callback_ServiceRegistration = 2,

	/*! When Service unregisters to this controller or timeout to response. */
	//DRMControl_Callback_ServiceUnRegistration = 3,

	/*! When the DRMControl object thread has been stopped. */
	DRMControl_Callback_Stopped = 4,

	/*! When error occurs in thread. */
	DRMControl_Callback_Error = 5,

} EDRMControl_CallbackType;


/*!
 *******************************************************************************
 * \brief
 * Callback function to report the event of \b DRMControl object.
 *
 * \param dwInstance
 * \a (i) bypass external 32-bit data to callback function.
 *
 * \param dwCallbackType
 * \a (i) the report type at this callback. 
 *
 * \param pvParam
 * \a (i) point to the parameter that every type has its definition.
 *
 * \retval S_OK
 * callback response OK.
 * \retval S_FAIL
 * callback response failed.
 *
 * \remark
 * Callback type is described as following:
 * \b DRMControl_Callback_DiscoveryResult: When discovery result is finished,   
 * DRMControl object feedbacks the result via callback function. The pvParam is
 * the structure \b TDRMServiceInfo that contains all the Service informations
 * found by this controller.
 *
 * \b DRMControl_Callback_ServiceRegistration: When controller receives the   
 * registration information from other Service, DRMControl object feedbacks
 * the information via callback function. The pvParam is the structure 
 * \b TDRMServiceInfo that contains the Service informations.
 * 
 * \b DRMControl_Callback_ServiceUnRegistration: When controller receives the   
 * unregistration information from other Service, DRMControl object feedbacks
 * the information via callback function. The pvParam is the structure 
 * \b TDRMServiceInfo that contains the Service informations.  
 * 
 * \b DRMControl_Callback_Stopped: When the thread of DRMControl object has
 * stopped, DRMControl object responses the status via callback function. The
 * pvParam is NULL.  
 * 
 * \b DRMControl_Callback_Error: When the error status of DRMControl object 
 * happens, DRMControl object responses the status via callback function. The
 * pvParam is NULL.  
 *
 * \see DRMControl_SetCallback
 * \see EDRMControl_CallbackType
 * \see TDRMServiceInfo
 *
 **************************************************************************** */
#ifdef _WIN32
typedef DWORD (__stdcall *FDRMControlCallback)(HANDLE hInstance,	EDRMControl_CallbackType eDRMControlCallbackType,void  *pvParam);
#else
typedef DWORD (*FDRMControlCallback)(HANDLE hInstance,	EDRMControl_CallbackType eDRMControlCallbackType,void  *pvParam);
#endif
/*! A data structure of \b DRMControl search. Used in function
* \b DRMControl_Create to set the range IP. */
typedef struct T_DRMControl_Range_IP
{
	DWORD dwRangeIPStart;
	DWORD dwRangeIPEnd;
}TDRMControlRangeIP;

/*! A data structure of \b DRMControl object. Used in function
 * \b DRMControl_Create to set the initial options. */
typedef struct
{

	/*! Maximum discovery items that the controller can handle. */
	DWORD dwMaxDiscoveryItem;

	
	/*! DRMControl port number. */
	unsigned short usDRMControlPort;

	/*! Create 169.254.x.x interface or not (TRUE or FALSE*/
	DWORD		dwAliasIP;

} TDRMControlCreateOptions;

#ifdef __cplusplus
extern "C" {
#endif

/*!
 *******************************************************************************
 * \brief
 * Create DRMControl instance and initialize it.
 *
 * \param phObject
 * \a (o) pointer to receive the instance's handle of this object.
 *
 * \param pDRMControlInitOptions
 * \a (i/o) the pointer of data structure \b TDRMControlCreateOptions for setting
 * the initialization parameters of the \b DRMControl instance. If you did not
 * set some parameters which are needed, the default value will be set and write
 * back to the corresponding fields.
 *
 * \retval S_OK
 * Initialize \b DRMControl OK.
 * \retval S_FAIL
 * Initialize \b DRMControl failed.
 *
 * \remark
 * This function should be called before using this instance.
 *
 * \see DRMControl_Close
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_Create(HANDLE *phObject, TDRMControlCreateOptions *pDRMControlInitOptions);

/*!
 *******************************************************************************
 * \brief
 * Delete an instance of the \b DRMControl object.
 *
 * \param phObject
 * \a (i/o) the pointer to the handle of the \b DRMControl instance.
 *
 * \retval S_OK
 * Release DRMControl OK.
 * \retval S_FAIL
 * Release DRMControl failed.
 *
 * \remark
 * After the instance is released, the handle of this instance will be set to
 * zero.
 *
 * \see DRMControl_Create
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_Close(HANDLE *phObject);


/*!
 *******************************************************************************
 * \brief
 * Set the callback function of DRMControl object
 *
 * \param hObject
 * \a (i) a handle of \b DRMControl instance.
 *
 * \param dwInstance
 * \a (i) bypass external 32-bit data to callback function.
 *
 * \param pfDRMControlCallback
 * \a (i) the function pointer of function type \b FDRMControlCallback. 
 *
 * \retval S_OK
 * set DRMControl callback function OK.
 * \retval S_FAIL
 * set DRMControl callback function failed.
 *
 * \remark
 * NONE
 *
 * \see DRMControl_Create
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_SetCallback(HANDLE hObject, HANDLE hInstance, FDRMControlCallback fDRMControlCallback);


/*!
 *******************************************************************************
 * \brief
 * Start the DRMControl mechanism
 *
 * \param hObject
 * \a (i) a handle of \b DRMControl instance.
 *
 * \param dwThreadPriority
 * \a (i) the thread priority of \b DRMControl thread. 
 *
 * \retval S_OK
 * start DRMControl mechanism OK.
 * \retval S_FAIL
 * start DRMControl mechanism failed.
 *
 * \remark
 * NONE
 *
 * \see DRMControl_Create 
 * \see DRMControl_SetParameters
 * \see DRMControl_SetCallback
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_Start(HANDLE hDRMControlHandle);



/*!
 *******************************************************************************
 * \brief
 * Stop the DRMControl mechanism
 *
 * \param hObject
 * \a (i) a handle of \b DRMControl instance.
 *
 *
 * \retval S_OK
 * stop DRMControl mechanism OK.
 * \retval S_FAIL
 * stop DRMControl mechanism failed.
 *
 * \remark
 * NONE
 *
 * \see DRMControl_Create 
 * \see DRMControl_Start
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_Stop(HANDLE hDRMControlHandle);

/*!
*******************************************************************************
* \brief
* Manual to discover the DRM's Service of specific IPs. The result is
* reported via callback
*
* function.
*
* \param hObject
* \a (i) a handle of \b DRMControl instance.
*
*
* \retval S_OK
* Start the procedure of Service discovery successfully.
*
* \retval S_FAIL
* Start the procedure of Service discovery failed.
*
* \remark
* Before you discover DRM's Service manually, be sure that the DRM control has
* been started. The result is reported by callback function.
*
* \see DRMControl_Start
* \see DRMControl_SetCallback
*
**************************************************************************** */
SCODE DLLAPI DRMControl_DiscoveryByRangeIP(HANDLE hDRMControlHandle, const TDRMControlRangeIP *ptRangeIP);

/*!
 *******************************************************************************
 * \brief
 * Manual to discover the DRM's Service of specific MAS address. The result is 
 * reported via callback
 *
 * function.
 *
 * \param hObject
 * \a (i) a handle of \b DRMControl instance.
 *
 *
 * \retval S_OK
 * Start the procedure of Service discovery successfully.
 *
 * \retval S_FAIL
 * Start the procedure of Service discovery failed.
 *
 * \remark
 * Before you discover DRM's Service manually, be sure that the DRM control has
 * been started. The result is reported by callback function.
 *
 * \see DRMControl_Start
 * \see DRMControl_SetCallback
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_DiscoveryByMAC(HANDLE hDRMControlHandle, char *pcMACAddress);

/*!
 *******************************************************************************
 * \brief
 * Manual to discover all the DRM's Service. The result is reported via callback
 * function.
 *
 * \param hObject
 * \a (i) a handle of \b DRMControl instance.
 *
 *
 * \retval S_OK
 * Start the procedure of Service discovery successfully.
 *
 * \retval S_FAIL
 * Start the procedure of Service discovery failed.
 *
 * \remark
 * Before you discover DRM's Service manually, be sure that the DRM control has
 * been started. The result is reported by callback function.
 *
 * \see DRMControl_Start
 * \see DRMControl_SetCallback
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_Discovery(HANDLE hDRMControlHandle);

/*!
 *******************************************************************************
 * 20120406 Rick
 * \brief
 * Manual to get EZ Installation information.
 *
 * \param dwEZVersion
 * \a (i) the value of EZVersion.
 *
 * \param ptCap
 * \a (i/o) the pointer of data structure \b TEZInstallCap which is used to store EZ
 * installation information.
 *
 * \retval S_OK
 * Parse the EZVersion successfully.
 *
 * \retval S_FAIL
 * Parsing the EZVersion failed or null-pointer reference.
 *
 * \remark
 * User can get the value of EZVersion via pvCallbackData.
 *
 * \see DRMControl_SetCallback
 *
 **************************************************************************** */
SCODE DLLAPI DRMControl_ParseEZVersion(DWORD dwEZVersion, TEZInstallCap *ptCap);

#ifdef __cplusplus
}
#endif

#endif	// DRMControl
