#ifndef AVSYNCLIVEDIGITALZOOMWRAPPER_H
#define AVSYNCLIVEDIGITALZOOMWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size 


typedef struct tAvSyncLiveDigitalZoomWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCDIGITALZOOMWRAPPERPARAM;  // Structure : parameters

class CAvSyncLiveDigitalZoomWrapper
{
private:
	HANDLE m_hAvSync;       // AvSynchronizer handle
	HANDLE m_hLiveChannel;  // Live channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCDIGITALZOOMWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	CAvSyncLiveDigitalZoomWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncLiveDigitalZoomWrapper();

	SCODE Start();
	SCODE Stop();

	SCODE UpdateChannelMediaType(DWORD dwMediaType);
	SCODE UpdateChannelShowBMP();
	SCODE InputEncodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);

	SCODE SetDigitalZoomOptions(HWND hTarget, HWND hZoomas);
};

#endif  // AVSYNCLIVEDIGITALZOOMWRAPPER_H