// DisplayAndGetRawDataWithPlaybackChannelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DisplayAndGetRawDataWithPlaybackChannel.h"
#include "DisplayAndGetRawDataWithPlaybackChannelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "datapacketdef.h"
#include "parsedatapacket.h"
#include "AvSyncPlaybackGetRawWrapper.h"
#include "DataPacketParser.h"

#define MAX_PLAYSPEED_COUNT 3         // Max count of multiples/divisors of play speed
#define TIMESTAMP_BUF_SIZE  200       // Timestamp buffer size
#define PATHBUF_SIZE        MAX_PATH  // Max size of decode directory path buffer


DWORD WINAPI ReadRawFileThread(LPVOID lpParam);  // Read raw file thread 

SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);      // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                            // AvSynchronizer Display callback function
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFOEX *tFrameInfoEx);  // AvSynchronizer Decode Frame callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDisplayAndGetRawDataWithPlaybackChannelDlg dialog




CDisplayAndGetRawDataWithPlaybackChannelDlg::CDisplayAndGetRawDataWithPlaybackChannelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayAndGetRawDataWithPlaybackChannelDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FILEPATH, m_editboxFilePath);
	DDX_Control(pDX, IDC_BUTTON_PLAY, m_buttonPlay);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_EDIT_SAVEDECODEDATALOCATION, m_editboxSaveDecodeDataLocation);
	DDX_Control(pDX, IDC_BUTTON_SETUPDECODEDATALOCATION, m_buttonSetupDecodeDataLocation);
	DDX_Control(pDX, IDC_CHECK_USERGB, m_chkboxUseRGB);
	DDX_Control(pDX, IDC_CHECK_USEYUV, m_chkboxUseYUV);
}

BEGIN_MESSAGE_MAP(CDisplayAndGetRawDataWithPlaybackChannelDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPENFILE, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonOpenfile)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonPlay)	
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_SETUPDECODEDATALOCATION, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonSetupdecodedatalocation)
	ON_BN_CLICKED(IDC_CHECK_USERGB, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedCheckUsergb)
	ON_BN_CLICKED(IDC_CHECK_USEYUV, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedCheckUseyuv)
	
	ON_MESSAGE(WM_USER_RESETDLGBUTTON, &CDisplayAndGetRawDataWithPlaybackChannelDlg::OnResetDlgButton)  // Specific message map : WM_USER_RESETDLGBUTTON -> OnResetDlgButton
END_MESSAGE_MAP()


// CDisplayAndGetRawDataWithPlaybackChannelDlg message handlers

BOOL CDisplayAndGetRawDataWithPlaybackChannelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialization (Appended)
	//
	m_bStop  = FALSE;

	m_pszSaveDirectoryPath = new char [PATHBUF_SIZE];
	
	memset(m_pszSaveDirectoryPath, 0, PATHBUF_SIZE);
	
	m_hDisplay = GetDlgItem(IDC_STATIC_DISPLAY)->GetSafeHwnd();

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	m_hReadRawFileThread = NULL;
	
	// Construct a CAvSyncPlaybackGetRawWrapper object
	m_pAVWrapper = new CAvSyncPlaybackGetRawWrapper(this->GetSafeHwnd(), m_hDisplay, m_hBMP, AvSynchronizerStatusCallBack, AvSynchronizerDisplayCallBack, (DWORD)this, (DWORD)this);  

	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_chkboxUseYUV.SetCheck(BST_CHECKED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDisplayAndGetRawDataWithPlaybackChannelDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnDestroy()
{
	if	(m_hReadRawFileThread != NULL)
	{	
		if	(!m_bStop)
		{	
			m_bStop = TRUE;

			// Wait for the "ReadRawFileThread"
			WaitForSingleObject(m_hReadRawFileThread, INFINITE);
		}

		// Close thread handle
		CloseHandle(m_hReadRawFileThread);
	}
	
	delete m_pAVWrapper;  // Destroy the CAvSyncPlaybackGetRawWrapper object

	if	(m_hDisplay != NULL)
	{
		::DestroyWindow(m_hDisplay);
	}

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}

	delete [] m_pszSaveDirectoryPath;
	
	CDialog::OnDestroy();
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonOpenfile()
{
	char szFileFilter[] = "All Files (*.*)|*.*||";
	
	CFileDialog fDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFileFilter);

	if	(fDlg.DoModal() == IDOK)
	{
		m_strFilePath = fDlg.GetPathName();

		m_editboxFilePath.SetWindowText(m_strFilePath.GetBuffer());

		m_buttonPlay.EnableWindow(TRUE);
	}
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonPlay()
{
	UpdateData(TRUE);

	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeOptions(PF_RGB24, AvSynchronizerFrameDecodeCallback, (DWORD)this);
	}
	else if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeOptions(PF_YUV, AvSynchronizerFrameDecodeCallback, (DWORD)this);
	}
	else
	{
		return;
	}

	SCODE scRet;
	
	scRet = m_pAVWrapper->Play();  // Play

	if	(scRet != S_OK)
	{
		return;
	}

	m_bStop = FALSE;

	m_hReadRawFileThread = CreateThread(NULL, 0, ReadRawFileThread, this, 0, &m_dwThreadID);  // Start "ReadRawFileThread"

	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetupDecodeDataLocation.EnableWindow(FALSE);
	m_chkboxUseRGB.EnableWindow(FALSE);
	m_chkboxUseYUV.EnableWindow(FALSE);
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonStop()
{
	m_buttonStop.EnableWindow(FALSE);	
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonSetupDecodeDataLocation.EnableWindow(TRUE);
	m_chkboxUseRGB.EnableWindow(TRUE);
	m_chkboxUseYUV.EnableWindow(TRUE);

	m_bStop = TRUE;
	
	m_pAVWrapper->Stop();  // Stop

	if	(m_hReadRawFileThread)
	{
		// Wait for the "ReadRawFileThread"
		WaitForSingleObject(m_hReadRawFileThread, INFINITE);
	}
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedCheckUsergb()
{
	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseYUV.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseYUV.SetCheck(BST_CHECKED);
	}
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedCheckUseyuv()
{
	if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseRGB.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseRGB.SetCheck(BST_CHECKED);
	}
}

void CDisplayAndGetRawDataWithPlaybackChannelDlg::OnBnClickedButtonSetupdecodedatalocation()
{
	char szDirectoryPath[PATHBUF_SIZE] = "\0";

	BROWSEINFO tBrowseInfo;

	tBrowseInfo.hwndOwner      = this->GetSafeHwnd();
	tBrowseInfo.pidlRoot       = NULL;
	tBrowseInfo.pszDisplayName = szDirectoryPath;
	tBrowseInfo.lpszTitle      = "Please select decode directory path";
	tBrowseInfo.ulFlags        = BIF_RETURNONLYFSDIRS;
	tBrowseInfo.lpfn           = NULL;
    tBrowseInfo.lParam         = 0;
    tBrowseInfo.iImage         = 0;

	LPITEMIDLIST pItemIDList = SHBrowseForFolder(&tBrowseInfo);
	
	if (pItemIDList == NULL)
	{
        return;
	}

    if (!SHGetPathFromIDList(pItemIDList, szDirectoryPath))
	{
		return;
	}

	strcpy_s(m_pszSaveDirectoryPath, PATHBUF_SIZE, szDirectoryPath);
	
	m_editboxSaveDecodeDataLocation.SetWindowText(szDirectoryPath);

	// Release ITEMIDLIST use IMalloc interface	
	IMalloc *pIMalloc = NULL;

	if	(SUCCEEDED(SHGetMalloc(&pIMalloc)))
	{
		pIMalloc->Free(pItemIDList);
		
		pIMalloc->Release();
	}
}

LRESULT CDisplayAndGetRawDataWithPlaybackChannelDlg::OnResetDlgButton(WPARAM, LPARAM)
{
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonSetupDecodeDataLocation.EnableWindow(TRUE);
	m_chkboxUseRGB.EnableWindow(TRUE);
	m_chkboxUseYUV.EnableWindow(TRUE);

	return 1;
}

// Function     : ReadRawFileThread (Thread)
// Description  : Read data from raw file and input the data to playback channel
// Parameter    : 
//              | [in] lpParam @Parameter passed to the thread
// Return value :
//              | 0 @Success
//              | 1 @Fail
//
DWORD WINAPI ReadRawFileThread(LPVOID lpParam)
{	
	CDisplayAndGetRawDataWithPlaybackChannelDlg *pDlg = (CDisplayAndGetRawDataWithPlaybackChannelDlg *)lpParam;

	// Construct a CDataPacketParser object
	CDataPacketParser *pParser = new CDataPacketParser(pDlg->m_strFilePath.GetBuffer());  

	DWORD dwStreamType = pParser->GetMediaStreamType();

	pDlg->m_pAVWrapper->UpdatePlaybackChannelMediaType(dwStreamType);

	TMediaDataPacketInfoV3 tPacketInfo;
	
	SCODE scRet = S_OK;

	while	(!pDlg->m_bStop && (scRet == S_OK))
	{
		// Get one media data packet info form file
		scRet = pParser->GetOneMediaDataPacketInfo(&tPacketInfo);		

		// Input the data packet to playback channel
		scRet = pDlg->m_pAVWrapper->InputDataPacketToChannel(&tPacketInfo);

		pParser->EmptyBuffer();
	}

	if	(!pDlg->m_bStop)
	{
		// User does not stop the channel. 
		// Wait until the audio and video elements in AvSynchronizer's queue are all played then stop the channel
		pDlg->m_bStop = TRUE;

		pDlg->m_pAVWrapper->WaitAVQueueEmpty();

		pDlg->m_pAVWrapper->Stop();
	}
	else
	{
		// User stop the channel by pressing the stop button.
		pDlg->m_pAVWrapper->Stop();
	}

	delete pParser;  // Destroy CDataPacketParser object

	// Reset dialog buttons
	::PostMessage(pDlg->GetSafeHwnd(), WM_USER_RESETDLGBUTTON, 0, 0);

	return 0;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{	
	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));

	char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";
	
	if	((ptDisplayInfo->dwFlag & DIF_CONNECTING) == 0)
	{
		// Print timestamp on the top-right of display window	
		if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
		{
			struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

			sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
																						 ptmTimeStamp->tm_mon + 1, 
																						 ptmTimeStamp->tm_mday,
																						 ptmTimeStamp->tm_hour, 
																						 ptmTimeStamp->tm_min, 
																						 ptmTimeStamp->tm_sec);

			SIZE szTimeStampBufSize;

			GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

			TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
		}
	}
	else
	{
		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "Connecting...");

		TextOut(hDC, ptDisplayInfo->ptOrigin.x, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}
	
	return S_OK;
}

// This callback function is used to notify the application the decoded audio or video frame, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFOEX *tFrameInfoEx)
{
	CDisplayAndGetRawDataWithPlaybackChannelDlg *pDlg = (CDisplayAndGetRawDataWithPlaybackChannelDlg *)dwContext;
	
	FILE *pRawVideoFile = NULL;
	FILE *pRawAudioFile = NULL;

	char szFilePathBuf[PATHBUF_SIZE] = "\0";

	EPIXELFORMAT ePixelFormat = EPIXELFORMAT(pDlg->m_pAVWrapper->m_dwDecodeFormat);

	if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_VIDEO_ONLY)  // Save video raw data
	{
		switch	(ePixelFormat)
		{
		case PF_RGB24:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.rgb", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		case PF_YUV:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.yuv", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		default:
			{
				break;
			}
		}

		fopen_s(&pRawVideoFile, szFilePathBuf, "ab");

		if	(pRawVideoFile != NULL)
		{
			fwrite(tFrameInfoEx->tF.tVideoFrame.pbyPicture, sizeof(BYTE), tFrameInfoEx->tF.tVideoFrame.dwSize, pRawVideoFile);

			fclose(pRawVideoFile);
		}
	}
	else if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_AUDIO_ONLY)  // Save audio raw data
	{
		sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Audio.pcm", pDlg->m_pszSaveDirectoryPath);

		fopen_s(&pRawAudioFile, szFilePathBuf, "ab");

		if	(pRawAudioFile != NULL)
		{
			fwrite(tFrameInfoEx->tF.tAudioFrame.pbySound, sizeof(BYTE), tFrameInfoEx->tF.tAudioFrame.dwSize, pRawAudioFile);

			fclose(pRawAudioFile);
		}
	}

	return S_OK;
}