#ifndef DATABROKERCONNECTWRAPPER_H
#define DATABROKERCONNECTWRAPPER_H

#include <windows.h>
#include "DataBroker.h"

#define DB_ERRMSGBUF_SIZE 200  // Error message buffer size
#define DB_PARAM_BUF_SIZE 100  // Parameter buffer size


typedef struct tDatabrokerConnectWrapperParam
{
	WORD   wHttpPort;
	TCHAR  szIPAddr[DB_PARAM_BUF_SIZE];
	TCHAR  szServerType[DB_PARAM_BUF_SIZE];
	TCHAR  szUserID[DB_PARAM_BUF_SIZE];
	TCHAR  szPassword[DB_PARAM_BUF_SIZE];

	TDataBrokerStatusCallback pfStatus;
	TDataBrokerAVCallback pfAV;
	
	DWORD dwStatusContext;
	DWORD dwAVContext;

}TDATABROKERCONNECTWRAPPERPARAM;  // Structure : parameters

class CDataBrokerConnectWrapper
{
private:
	HANDLE m_hDatabroker;     // Databroker handle
	HANDLE m_hConn;           // Connection instance handle

	char m_szErrMsgBuf[DB_ERRMSGBUF_SIZE];  // Error message buffer

	TDATABROKERCONNECTWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateConnection();
	SCODE DeleteConnection();
	SCODE SetConnectionOptions();

public:	
	CDataBrokerConnectWrapper(TDataBrokerStatusCallback pfStatus, TDataBrokerAVCallback pfAV, DWORD dwStatusContext, DWORD dwAVContext);
	~CDataBrokerConnectWrapper();

	SCODE Connect(WORD wHttpPort, TCHAR *pszIPAddr, TCHAR *pszServerType, TCHAR *pszUserID, TCHAR *pszPassword);
	SCODE Disconnect();
};

#endif  // DATABROKERCONNECTWRAPPER_H