#ifndef AVSYNCDECODEWRAPPER_H
#define AVSYNCDECODEWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size


typedef struct tAvSyncDecodeWrapperParam
{
	LPDECODEFRAMECALLBACK pfDecodeFrame;
	
	DWORD dwDecodeFrameContext;

}TAVSYNCDECODEWRAPPERPARAM;  // Structure : parameters

class CAvSyncDecodeWrapper
{
private:
	HANDLE m_hAvSync;         // AvSynchronizer handle
	HANDLE m_hDecodeChannel;  // Decode channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCDECODEWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:	
	DWORD m_dwDecodeFormat;  // Decode data format

	CAvSyncDecodeWrapper(LPDECODEFRAMECALLBACK pfDecodeFrame, DWORD dwDecodeFrameContext);
	~CAvSyncDecodeWrapper();

	SCODE SetDecodeFormat(DWORD dwFormat);
	SCODE InputToBeDecodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);
};

#endif  // AVSYNCDECODEWRAPPER_H