#ifndef AVSYNCLIVEWRAPPER_H
#define AVSYNCLIVEWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size 


typedef struct tAvSyncLiveWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCLIVEWRAPPERPARAM;  // Structure : parameters

class CAvSyncLiveWrapper
{
private:
	HANDLE m_hAvSync;       // AvSynchronizer handle
	HANDLE m_hLiveChannel;  // Live channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCLIVEWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	CAvSyncLiveWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncLiveWrapper();

	SCODE Start();
	SCODE Stop();

	SCODE UpdateChannelMediaType(DWORD dwMediaType);
	SCODE UpdateChannelShowBMP();
	SCODE InputEncodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);
};

#endif  // AVSYNCLIVEWRAPPER_H